#!/usr/bin/env python
 
## This file is part of HamsiManager.
## 
## Copyright (c) 2010 - 2012 Murat Demir <mopened@gmail.com>      
##
## Hamsi Manager is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## Hamsi Manager is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with HamsiManager; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from cx_Freeze import setup, Executable

includes = []
excludes = ['_gtkagg', '_tkagg', 'bsddb', 'curses', 'email', 'pywin.debugger',
            'pywin.debugger.dbgcon', 'pywin.dialogs', 'tcl',
            'Tkconstants', 'Tkinter']
packages = ['Amarok','Core','Databases','Details','InputOutputs','Languages',
        'MyPlugins','Options','SearchEngines','Tables','Taggers','Tools','Viewers', 
        #'pysqlite2', # For only (python<2.7)
        'sqlite3', # For only (python>=2.7)
        'PyKDE4', # If you want to use KDE4 (Is not requirement but however it is very better than)
        'hashlib', 'urllib', 'PyQt4']
path = []
include_files = [("Amarok","Amarok"),("Languages","Languages"),("MyPlugins","MyPlugins"),("SearchEngines","SearchEngines"),("Taggers","Taggers"),("Themes","Themes")]

Exe_Target = Executable(
    # what to build
    script = "HamsiManager.py",
    initScript = None,
    #base = 'Win32GUI',
    #targetDir = r"dist",
    targetName = "HamsiManager",
    compress = True,
    copyDependentFiles = False,
    appendScriptToExe = False,
    appendScriptToLibrary = False,
    #icon = r"resources\icons\nya.ico"
    )

setup(
   
    version = "0.9",
    description = "No Description",
    author = "Murat Demir",
    name = "HamsiManager",
    options = {"build_exe": {"includes": includes,
                             "excludes": excludes,
                             "packages": packages,
                             "path": path,
                             "include_files":include_files,
                             }
               },
    executables = [Exe_Target]
    )






























#!/usr/bin/env python
 
## This file is part of HamsiManager.
## 
## Copyright (c) 2010 - 2012 Murat Demir <mopened@gmail.com>      
##
## Hamsi Manager is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## Hamsi Manager is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with HamsiManager; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
from cx_Freeze import setup, Executable
from Core import Variables
import InputOutputs

includes = []
excludes = ["_gtkagg", "_tkagg", "bsddb", "curses", "email", 
            "pywin.debugger", "pywin.debugger.dbgcon", "pywin.dialogs", 
            "tcl","Tkconstants", "Tkinter"]
packages = ["Amarok","Core","Databases","Details","InputOutputs","Languages",
        "MyPlugins","Options","SearchEngines","Tables","Taggers","Tools","Viewers", 
        #"pysqlite2", # For only (python<2.7)
        "sqlite3", # For only (python>=2.7)
        "PyKDE4", # If you want to use KDE4 (Is not requirement but however it is very better than)
        "eyeD3", "musicbrainz2", # not available in python 3.x
        "hashlib", "tarfile", "urllib", "PyQt4"]
path = []
include_files = [("Amarok","Amarok"),("Languages","Languages"),("MyPlugins","MyPlugins"),("SearchEngines","SearchEngines"),("Taggers","Taggers"),("Themes","Themes")]

exeBase = "Console" # "Win32GUI" for windows
fileExtension = "" # ".exe" for windows

MainExe = Executable(
    script = "HamsiManager.py",
    initScript = None,
    base = exeBase,
    targetName = "HamsiManager" + fileExtension,
    compress = True,
    copyDependentFiles = False,
    appendScriptToExe = False,
    appendScriptToLibrary = False,
    icon = "Themes/Default/Images/HamsiManager-128x128.ico"
    )
    
ReconfigureExe = Executable(
    script = "Reconfigure.py",
    initScript = None,
    base = exeBase,
    targetName = "Reconfigure" + fileExtension,
    compress = True,
    copyDependentFiles = False,
    appendScriptToExe = False,
    appendScriptToLibrary = False,
    )
    
InstallExe = Executable(
    script = "install.py",
    initScript = None,
    base = exeBase,
    targetName = "HamsiManagerInstaller" + fileExtension,
    compress = True,
    copyDependentFiles = False,
    appendScriptToExe = False,
    appendScriptToLibrary = False,
    )

#setup(
#    version = Variables.version,
#    description = InputOutputs.readFromFile(os.getcwd() + "/Languages/About_en_GB", "utf-8"),
#    author = "Murat Demir",
#    name = "HamsiManager",
#    options = {"build_exe": {"includes": includes,
#                             "excludes": excludes,
#                             "packages": packages,
#                             "path": path,
#                             "include_files":include_files,
#                             }
#               },
#    executables = [MainExe, ReconfigureExe, InstallExe]
#    )
    

ConfigureUpdateExe = Executable(
    script = "ConfigureUpdate.py",
    initScript = None,
    base = exeBase,
    targetName = "ConfigureUpdate" + fileExtension,
    compress = True,
    copyDependentFiles = True,
    appendScriptToExe = True,
    appendScriptToLibrary = True,
    )

setup(
    version = Variables.version,
    description = InputOutputs.readFromFile(os.getcwd() + "/Languages/About_en_GB", "utf-8"),
    author = "Murat Demir",
    name = "HamsiManagerConfigureUpdate",
    options = {"build_exe": {"includes": [],
                             "excludes": excludes,
                             "packages": [],
                             "path": [],
                             "include_files":[],
                             }
               },
    executables = [ConfigureUpdateExe]
    )


























# ======================================================#
# File automagically generated by GUI2Exe version 0.5.0
# Andrea Gavana, 01 April 2007
# ======================================================#

# Let's start with some default (for me) imports...

from cx_Freeze import setup, Executable



# Process the includes, excludes and packages first

includes = []
excludes = ['_gtkagg', '_tkagg', 'bsddb', 'curses', 'email', 'pywin.debugger',
            'pywin.debugger.dbgcon', 'pywin.dialogs', 'tcl',
            'Tkconstants', 'Tkinter']
packages = ["plugins"]
path = []
include_files = [("resources","resources"),("plugins","plugins")]

# This is a place where the user custom code may go. You can do almost
# whatever you want, even modify the data_files, includes and friends
# here as long as they have the same variable name that the setup call
# below is expecting.

entry_points="""
        [nya.s_tools]
        database = plugins.database
        font = plugins.font
        game = plugins.game
        map = plugins.map
        script = plugins.script
        sprite = plugins.sprite
        tileset = plugins.tileset"""

# The setup for cx_Freeze is different from py2exe. Here I am going to
# use the Python class Executable from cx_Freeze


GUI2Exe_Target_1 = Executable(
    # what to build
    script = "nyed.py",
    initScript = None,
    base = 'Win32GUI',
    targetDir = r"dist",
    targetName = "nyed.exe",
    compress = True,
    copyDependentFiles = False,
    appendScriptToExe = False,
    appendScriptToLibrary = False,
    icon = r"resources\icons\nya.ico"
    )


# That's serious now: we have all (or almost all) the options cx_Freeze
# supports. I put them all even if some of them are usually defaulted
# and not used. Some of them I didn't even know about.

setup(
   
    version = "0.1",
    description = "No Description",
    author = "Rogier Sluimers",
    name = "cx_Freeze Sample File",
    entry_points = """
        [nya.s_tools]
        database = plugins.database
        font = plugins.font
        game = plugins.game
        map = plugins.map
        script = plugins.script
        sprite = plugins.sprite
        tileset = plugins.tileset""",
   
    options = {"build_exe": {"includes": includes,
                             "excludes": excludes,
                             "packages": packages,
                             "path": path,
                             "include_files":include_files,
                             }
               },
                         
    executables = [GUI2Exe_Target_1]
    )

# This is a place where any post-compile code may go.
# You can add as much code as you want, which can be used, for example,
# to clean up your folders or to do some particular post-compilation
# actions.

# No post-compilation code added


# And we are done. That's a setup script :-D




















#!/usr/bin/python

# from distutils.core import setup
# import py2exe
# data_files =[("Microsoft.VC90.CRT", glob(r'c:\dev\ms-vc-runtime\*.*'))]
# #["*.py","Core/*.py","Languages/*.*", "MyPlugins/*.*", "SearchEngines/*.py"
# #, "SearchEngines/musicbrainz2/*.py", "SearchEngines/musicbrainz2/data/*.py",
# #"Tables/*.py", "Themes/Default/*.py", "Themes/Default/Images/*.py"]
# #setup(windows=['HamsiManager.py'],
# setup(console=['HamsiManager.py'],
   # scripts=["HamsiManager"],
   # name='HamsiManager',
   # version='0.9',
   # description='HamsiManager ',
   # author='Murat Demir',
   # author_email='mopened@gmail.com',
   # url='http://www.metehan.us',
    # options={"py2exe": {"skip_archive": False, "includes": ["sip"],"bundle_files":1, "dll_excludes": ["MSVCP90.dll"]}},
    # zipfile=None,
    # packages = ['Amarok','Core','Databases','Details','InputOutputs','Languages',
       # 'MyPlugins','MyPlugins.InTheAmarok','MyPlugins.KDE4_CM','MyPlugins.KDE4_SM','MyPlugins.Krusader',
       # 'Options','SearchEngines','Tables','Taggers','Tools','Viewers'],
    # data_files=data_files)
   
   

# setup(
     # data_files=[("data", ["veri.db"])],
     # package_data={"lib.lib2":["data/*"]}
    # )
   
#from cx_Freeze import setup, Executable

#setup(
#      name = "HamsiManager",
#      version = "0.9",
#      description = "the typical 'Hello, world!' script",
#      executables = [Executable("HamsiManager.py")], 
#      excludes = ['_gtkagg', '_tkagg', 'bsddb', 'curses', 'email', 'pywin.debugger',
#            'pywin.debugger.dbgcon', 'pywin.dialogs', 'tcl',
#            'Tkconstants', 'Tkinter'], 
#      packages = ['Amarok','Core','Databases','Details','InputOutputs','Languages',
#        'MyPlugins','Options','SearchEngines','Tables','Taggers','Tools','Viewers'], 
#      copyDependentFiles=True 
#      )
   
# setup(console=['HamsiManager.py'],
   # scripts=["HamsiManager"],
   # name='HamsiManager',
   # version='0.9',
   # description='HamsiManager ',
   # author='Murat Demir',
   # author_email='mopened@gmail.com',
   # url='http://www.metehan.us',
    # options={"py2exe": {"skip_archive": False, "includes": ["sip"],"bundle_files":1, "dll_excludes": ["MSVCP90.dll"]}},
    # zipfile=None,
    # packages = ['Amarok','Core','Databases','Details','InputOutputs','Languages',
       # 'MyPlugins','MyPlugins.InTheAmarok','MyPlugins.KDE4_CM','MyPlugins.KDE4_SM','MyPlugins.Krusader',
       # 'Options','SearchEngines','Tables','Taggers','Tools','Viewers'],
    # data_files=data_files)
   
   
   
#D:\My Applications\HamsiManager>E:\Python\python.exe setup.py py2exe
#D:\My Applications\HamsiManager>E:\Python\python.exe setup.py build
#D:\My Applications\HamsiManager\dist\HamsiManager.exe

#E:\Python\python.exe "D:\My Applications\HamsiManager\HamsiManager.py"
#E:\Python3\python.exe "D:\My Applications\HamsiManager\HamsiManager.py"






#
#import os, sys, glob, fnmatch
#from Core from Core import Variables
#
### Added 10 Jan 2008
#from distutils.core import setup, Extension
#import distutils.command.install_data
#
### Code borrowed from wxPython's setup and config files
### Thanks to Robin Dunn for the suggestion.
### I am not 100% sure what's going on, but it works!
#def opj(*args):
#    path = os.path.join(*args)
#    return os.path.normpath(path)
#
### Added 10 Jan 2008
## Specializations of some distutils command classes
#class wx_smart_install_data(distutils.command.install_data.install_data):
#    """need to change self.install_dir to the actual library dir"""
#    def run(self):
#        install_cmd = self.get_finalized_command('install')
#        self.install_dir = getattr(install_cmd, 'install_lib')
#        return distutils.command.install_data.install_data.run(self)
#
#def find_data_files(srcdir, *wildcards, **kw):
#    # get a list of all files under the srcdir matching wildcards,
#    # returned in a format to be used for install_data
#    
#    ## A list of partials within a filename that would disqualify it
#    ## from appearing in the tarball.
#    badnames=[".pyc","~","no_"]
#    def walk_helper(arg, dirname, files):
#        if 'CVS' in dirname: ## ADD/CHANGE as you need here too.
#            return
#        names = []
#        lst, wildcards = arg
#        for wc in wildcards:
#            wc_name = opj(dirname, wc)
#            for f in files:
#                filename = opj(dirname, f)
#                #if ".pyc" not in filename:
#                ## This hairy looking line excludes the filename
#                ## if any part of one of  badnames is in it:
#                if not any(bad in filename for bad in badnames):
#                    if fnmatch.fnmatch(filename, wc_name) and not os.path.isdir(filename):
#                        names.append(filename)
#        if names:
#            lst.append( (dirname, names ) )
#
#    file_list = []
#    recursive = kw.get('recursive', True)
#    if recursive:
#        os.path.walk(srcdir, walk_helper, (file_list, wildcards))
#    else:
#        walk_helper((file_list, wildcards),
#                    srcdir,
#                    [os.path.basename(f) for f in glob.glob(opj(srcdir, '*'))])
#    return file_list
#
### This is a list of files to install, and where:
### Make sure the MANIFEST.in file points to all the right 
### directories too.
#files = find_data_files(os.getcwd() + "/", '*.*')
#
#from distutils.core import setup
#
#setup(name='HamsiManager',
#    version=Variables.version,
#    description='Hamsi Manager is an another different file manager.',
#    author='Murat Demir',
#    author_email='mopened@gmail.com',
#    url='http://hamsiapps.com/en/HamsiManager/',
#    license = "GNU GPLv3",
#    #packages = ['fontypythonmodules'],
#    
#    data_files = files,
#    
#    ## Borrowed from wxPython too:
#    ## Causes the data_files to be installed into the modules directory.
#    ## Override some of the default distutils command classes with my own.
#    cmdclass = { 'install_data':    wx_smart_install_data },
#    
#    #'fontypython' and 'fp' are in the root.
#    #scripts = ["hamsi", "hamsimanager"],
#    long_description = 'Hamsi Manager is an another different file manager.',
#    classifiers=[
#      'Development Status :: 4 - Beta',
#      'Environment :: X11 Applications :: Qt',
#      'Intended Audience :: End Users/Desktop',
#      'Intended Audience :: Developers',
#      'License :: OSI Approved :: GNU General Public License (GPL)',
#      'Operating System :: POSIX :: Linux',
#      'Programming Language :: Python',
#      'Topic :: Desktop Environment',
#      'Topic :: Text Processing :: Fonts'
#      ]
#)
#
#













#
#from distutils.core import setup
#from Core from Core import Variables
#import os
#
#currentDir = os.getcwd()
#fileList = []
#def readFiles(_DirPath):
#    global fileList
#    fList = []
#    for fileOrDirPath in os.listdir(_DirPath):
#        if fileOrDirPath.split("/")[-1]!=".svn" and fileOrDirPath[-1]!="~":
#            if os.path.isdir(_DirPath + "/" + fileOrDirPath):
#                readFiles(_DirPath + "/" + fileOrDirPath)
#            else:
#                fList.append( (_DirPath.replace(currentDir, "share/hamsi"), 
#                               [(_DirPath + "/" + fileOrDirPath).replace(currentDir + "/", "")]
#                               )
#                            )
#    if fList != []:
#        fileList.append(fList)
#        #fileList.append( (_DirPath.replace(currentDir, "share/hamsi"), fList) )
#
#readFiles(currentDir)
#
#setup(name='HamsiManager',
#      version=Variables.version,
#      description='Hamsi Manager is an another different file manager.',
#      author='Murat Demir',
#      author_email='mopened@gmail.com',
#      url='http://hamsiapps.com/en/HamsiManager/',
#      package_data = {"hamsi" : ["HamsiManager.desktop"]}
#      #data_files=fileList, 
#      #scripts=["HamsiManager.py"], 
#     )
#     
#print fileList

#packages=['Amarok', 'Core', 'Databases', 'Details', 'InputOutputs', 'Languages', 'MyPlugins', 'SearchEngines', 'Tables', 'Taggers', 'Tools', 'Viewers', 'ConfigureUpdate', 'HamsiManager', 'Reconfigure', 'install'],

#from setuptools import setup
#import sys
#import os, platform
#
## workaround to run the setup.py from ../elisa-core
#curdir = os.getcwd()
#if os.path.basename(curdir) != 'elisa-core' and os.path.isdir('elisa-core'):
#    os.chdir('elisa-core')
#
#from elisa.core import __version__, log
#from elisa.core.utils.dist import CMD_CLASS, PACKAGE_DATA
#
#from setuptools import find_packages
#
#try:
#    import py2exe
#except:
#    pass
#
#log.init()
#
#data_files = []
#py_exe_options = {}
#
#if platform.system() in ('Linux', 'SunOS'):
#    data_files.extend([('share/pixmaps', ['data/moovida.png']),
#                       ('share/man/man1', ['docs/moovida.1']),
#                       ('share/applications',
#                        ['data/moovida.desktop', 'data/moovida-mobile.desktop']),
#                       ('share/icons', ['data/moovida.png']),
#                       ('share/dbus-1/services',
#                        ['data/com.fluendo.elisa.service'])
#                      ])
#
#elif platform.system() == 'Windows':
#    module_include = ['tarfile', 'md5']
#    package_include = ['distutils']
#    module_exclude = ['gst', 'pygst', 'elisa', 'twisted', 'pgm', 'gtk', 'gobject']
#    dll_exclude = ['libglade-2.0-0.dll']
#
#    py_exe_options = {"custom_boot_script" : 'mswin32/win_set_env.py',
#                      "includes"           : module_include,
#                      "packages"           : package_include,
#                      "excludes"           : module_exclude,
#                      "dll_excludes"       : dll_exclude
#                      }
#
#setup(cmdclass=CMD_CLASS,
#               data_files=data_files,
#               name="elisa",
#               elisa_infos={'plugin_name': 'core'},
#               options={"py2exe": py_exe_options},
#               version=__version__,
#               description="Moovida",
#               author="The Moovida Team",
#               author_email="elisa@lists.fluendo.com",
#               maintainer="The Moovida Team",
#               maintainer_email="elisa@lists.fluendo.com",
#               long_description="""\
#Moovida is an open media center system to watch, listen, manage and
#share videos, files and music. It uses GStreamer, Python and OpenGL
#technologies. """,
#               url="http://moovida.org",
#               keywords=['multimedia', 'gstreamer', 'opengl'],
#               classifiers=['Development Status :: 3 - Alpha',
#                            'Environment :: X11 Applications',
#                            'Intended Audience :: End Users/Desktop',
#                            'Natural Language :: English',
#                            'Operating System :: OS Independent',
#                            'Programming Language :: Python',
#                            'Topic :: Multimedia :: Graphics :: 3D Rendering',
#                            'Topic :: Multimedia :: Sound/Audio',
#                            'Topic :: Multimedia :: Video',
#                           ],
#               test_suite='elisa',
#               zip_safe=False,
#               packages=find_packages(exclude=('mswin32*',)),
#               namespace_packages=['elisa',],
#               include_package_data=True,
#               package_data=PACKAGE_DATA,
#               entry_points={'distutils.commands':
#                                 ['build_po = elisa.core.utils.dist:build_po',
#                                  'bdist_elisa = elisa.core.utils.dist:bdist_elisa'],
#                             'distutils.setup_keywords':
#                                 ['elisa_infos = elisa.core.utils.dist:assert_dict_or_none',],
#                             'egg_info.writers':
#                                 ['elisa_infos.txt = elisa.core.utils.dist:write_dict',],
#                             'gui_scripts':
#                                ['elisa = elisa.core.launcher:main'],
#                            }
#              )


