#!/usr/bin/python
# -*- codding: utf-8 -*-



#
#from distutils.core import setup
#from Core from Core import Variables
#import os
#
#currentDir = os.getcwd()
#fileList = []
#def readFiles(_DirPath):
#    global fileList
#    fList = []
#    for fileOrDirPath in os.listdir(_DirPath):
#        if fileOrDirPath.split("/")[-1]!=".svn" and fileOrDirPath[-1]!="~":
#            if os.path.isdir(_DirPath + "/" + fileOrDirPath):
#                readFiles(_DirPath + "/" + fileOrDirPath)
#            else:
#                fList.append((_DirPath + "/" + fileOrDirPath).replace(currentDir + "/", ""))
#    if fList != []:
#        fileList.append( (_DirPath.replace(currentDir, "share/hamsi"), fList) )
#
#readFiles(currentDir)
#
#setup(name='HamsiManager',
#      version=Variables.version,
#      description='Hamsi Manager is an another different file manager.',
#      author='Murat Demir',
#      author_email='mopened@gmail.com',
#      url='http://hamsiapps.com/en/HamsiManager/',
#      data_files=fileList, 
#      #scripts=["HamsiManager.py"], 
#     )
#     
#print fileList






















# Copyright (c) 2010 Sebastian Wiesner <lunaryorn@googlemail.com>

# This program is free software. It comes without any warranty, to
# the extent permitted by applicable law. You can redistribute it
# and/or modify it under the terms of the Do What The Fuck You Want
# To Public License, Version 2, as published by Sam Hocevar. See
# http://sam.zoy.org/wtfpl/COPYING for more details.

"""
export_amarok_covers
====================

A script to export covers from the amarok cover database to the
corresponding album directories. Usage is quite simple, just execute
the script::

python export_amarok_covers

It can create desktop entries for covers to set the cover image as
directory icons::

python export_amarok_covers -e

Use :option:`--help` to get an overview of available options.

.. note::

As of now, the script does *not* work with Amarok's embedded MySQL
database, but only, if Amarok is configured to use an external
database.

.. moduleauthor:: Sebastian Wiesner <lunaryorn@googlemail.com>
"""


from __future__ import (print_function, division, unicode_literals,absolute_import)

import os
import sys
import logging
import subprocess
import shutil
from optparse import OptionParser
from contextlib import closing

import Image
from lxml import etree
from sqlalchemy import (MetaData, Table, Column, Integer, String,
                        ForeignKey, create_engine, select)
from sqlalchemy.sql.functions import coalesce
from sqlalchemy.engine.url import URL


def _log_check_call(logger, command):
    """
Call the ``command``, and return its standard output as :class:`unicode`
object. The invocation of ``command`` is logged to the given ``logger``
at DEBUG level.

Raise :exc:`OSError`, if the command does not exist, or could not be
executed for whatever reason, or :exc:`subprocess.CalledProcessError`,
if the command did not return exit code 0.
"""
    logger.debug('calling %r', command)
    proc = subprocess.Popen(command, stdout=subprocess.PIPE)
    stdout = proc.communicate()[0]
    if proc.returncode != 0:
        raise subprocess.CalledProcessError(proc.returncode, command)
    return stdout.decode(sys.getfilesystemencoding()).strip()


def kde4_resource_types():
    """
Return a list of all resource types supported by KDE 4.

This function uses :command:`kde4-config` to list resource types. Thus
it will raise :exc:`OSError`, if the command does not exist, or could
not be executed for whatever reason. Moreover it will raise
:exc:`subprocess.CalledProcessError`, if the command did not return exit
code 0.
"""
    types = _log_check_call(logging.getLogger('kde4.resources'),
                            ['kde4-config', '--types'])
    return frozenset(l.split('-', 1)[0].strip() for l in types.splitlines())


def kde4_locate(type, filename):
    """
Locate a resource of given ``type`` in the KDE directories.
``filename`` is the relative filename of the resource. Return the
absolute path of the resource, or ``None``, if the resource was not
found.

Raise :exc:`ValueError`, if ``type`` is not a valid type (see
:func:`kde4_resource_types()`).

This function uses :command:`kde4-config` to locate resources. Thus it
will raise :exc:`OSError`, if the command does not exist, or could not
be executed for whatever reason. Moreover it will raise
:exc:`subprocess.CalledProcessError`, if the command did not return exit
code 0.
"""
    if type not in kde4_resource_types():
        raise ValueError('unknown type {0}'.format(type))
    log = logging.getLogger('kde4.resources')
    log.debug('searching %s of type %s', filename, type)
    cmd = ['kde4-config', '--path', type, '--locate', filename]
    path = _log_check_call(log, cmd)
    if path:
        log.debug('found %s of type %s at %s', filename, type, path)
    return path or None


def kde4_write_config(filename, group, key, value):
    """
Write ``value`` for ``key`` in ``group`` to the given configuration
file.

``filename`` points to the configuration file to write to. Use
:func:`kde4_locate` to locate configuration files. ``group`` is the
group name, ``key`` the configuration key, ``value`` the configuration
value to write.

This function uses :command:`kwriteconfig` to write the configuration
setting. Thus it will raise :exc:`OSError`, if the command does not
exist, or could not be executed for whatever reason. Moreover it will
raise :exc:`subprocess.CalledProcessError`, if the command did not
return exit code 0.
"""
    log = logging.getLogger('kde4.config')
    log.debug('setting %s to %s in file %s, group %s',
              key, value, filename, group)
    cmd = ['kwriteconfig', '--file', filename, '--group', group,
           '--key', key, value]
    _log_check_call(log, cmd)


def kde4_read_config(filename, group, key, default=None):
    """
Read the configuration value for ``key`` from ``group`` in the
configuration file pointed to by ``filename``. If ``key`` does not
exist in ``group``, the ``default`` value is returned. If no
``default`` is given, ``None`` is returned.

Return the value as string.

This function uses :command:`kreadconfig` to read the configuration
setting. Thus it will raise :exc:`OSError`, if the command does not
exist, or could not be executed for whatever reason. Moreover it will
raise :exc:`subprocess.CalledProcessError`, if the command did not
return exit code 0.
"""
    log = logging.getLogger('kde4.config')
    log.debug('reading %s from file %s, group %s, default %s',
              key, filename, group, default)
    cmd = ['kreadconfig', '--file', filename, '--group', group,
           '--key', key]
    if default is not None:
        cmd.append('--default')
        cmd.append(default)
    return _log_check_call(log, cmd) or None


metadata = MetaData()
albums = Table('albums', metadata,
               Column('id', Integer, primary_key=True),
               Column('name', String),
               Column('image', None, ForeignKey('images.id')))
images = Table('images', metadata,
               Column('id', Integer, primary_key=True),
               Column('path', String(255)))
tracks = Table('tracks', metadata,
               Column('id', Integer, primary_key=True),
               Column('url', None, ForeignKey('urls.id')),
               Column('album', None, ForeignKey('albums.id')))
urls = Table('urls', metadata,
             Column('id', Integer, primary_key=True),
             Column('directory', None, ForeignKey('directories.id')))
directories = Table('directories', metadata,
                    Column('id', Integer, primary_key=True),
                    Column('deviceid', None, ForeignKey('devices.id')),
                    Column('dir', String))
devices = Table('devices', metadata,
                Column('id', Integer, primary_key=True),
                Column('lastmountpoint', String))


def export_cover(album, cover_file, directory, cover_name):
    """
Export a cover to a ``directory`` using the given ``cover_name`` and
return the path to the exported cover file.

``album`` is the name of the album, the ``cover_file`` belongs to.
``cover_file`` is the path to the cover_file file in amaroks cover
directory.

This cover will be exported to the given ``directory`` using the given
``cover_name``. If ``cover_name`` includes an extension, the cover will
be converted to the image format denoted by the extension. For
instance, the following line will export all covers in PNG format::

export_cover(album, cover, directory, 'cover.png')

If ``cover_name`` does not include an extension, the extension will be
chosen according to the image format of ``cover_file`` (which is most
likely JPEG). In this case, ``cover_file`` is simply copied, to avoid
potential quality loss due to repeated compression.

Return the path to the exported cover.
"""
    log = logging.getLogger('amarok.covers')
    cover = Image.open(cover_file)
    cover_ext = os.extsep + cover.format.lower()
    dest, dest_ext = os.path.splitext(os.path.join(directory, cover_name))
    if not dest_ext:
        dest_ext = cover_ext
    dest += dest_ext
    if os.path.normpath(dest) == os.path.normpath(cover_file):
        log.debug('skipping %s, cover_file already exported to %s',
                  album, directory)
    else:
        log.info('exporting cover_file of %s to %s', album, dest)
        if dest_ext != cover_ext:
            # conversion required
            cover.save(dest)
        else:
            # simple copy, if formats are the same, avoids quality loss due
            # to repeated compression
            shutil.copyfile(cover_file, dest)
    return dest


def create_desktop_entry(album, directory, cover_file):
    """
Create a `desktop entry`_ specifying the cover file as directory icon in
the album directory. Given such a desktop entry, file managers
compliant to the Desktop File Specification will use the cover file as
folder icon.

``album`` is the album, the cover belongs to. The desktop entry will be
created for ``directory``, using the given ``cover_file``. If
``cover_file`` is located inside ``directory``, it is linked using the
relative path, thus preserving the folder icon on folder renames or
copies.

The desktop entry file will be created using :func:`kde4_write_config`,
be sure to read its documentation, too.
"""
    if not os.path.exists(cover_file):
        return

    log = logging.getLogger('amarok.covers')
    if cover_file.startswith(directory):
        # turn into relative path
        cover_file = cover_file[len(directory):]
        cover_file = cover_file.lstrip(os.sep + (os.altsep or ''))
        cover_file = os.path.join(os.curdir, cover_file)
    log.info('creating desktop entry for %s in %s', album, directory)
    kde4_write_config(os.path.join(directory, '.directory'),
                      'Desktop Entry', 'Icon', cover_file)


def export_covers(connection, cover_name, create_desktop_entries=True):
    """
Export all covers from the database.

``connection`` is a SQLAlchemy connection to the Amarok database. This
function queries the database to find all covers, that need to be
exported. Each of these covers is exported using :func:`export_cover`
with the given ``cover_name``. Read the documentation of
:func:`export_cover` for information about ``cover_name``.

If ``create_desktop_entries`` is ``True`` (the default),
:func:`create_desktop_entry` is called for each exported cover.
"""
    log = logging.getLogger('amarok.covers')
    joined = albums.join(images).join(tracks).join(urls).join(
        directories).outerjoin(devices)
    stmt = select([albums.c.name.label('album'),
                   images.c.path.label('image_file'),
                   coalesce(devices.c.lastmountpoint, '/').label('mount'),
                   directories.c.dir.label('directory')],
                  from_obj=joined).distinct()
    with closing(connection.execute(stmt)) as result:
        for row in result:
            try:
                log.debug('fetched %(album)r, %(image_file)r, '
                          '%(directory)r, %(mount)r', dict(row))
                directory = os.path.normpath(
                    os.path.join(row['mount'], row['directory']))
                album = row['album']
                image_file = os.path.normpath(row['image_file'])
                try:
                    image_file = export_cover(album, image_file, directory,
                                              cover_name)
                except EnvironmentError:
                    log.exception('failed to export cover %s of %s to %s',
                                  image_file, album, directory)
                if create_desktop_entries:
                    create_desktop_entry(album, directory, image_file)
            except UnicodeDecodeError:
                log.exception('unexpected non-UTF-8 data found, '
                              'cover skipped')


def url_from_config(sql_config):
    """
Create a :class:`~sqlalchemy.engine.url.URL` object representing the
given database configuration. This url can be used to connect to the
database.
"""
    config_map = {'Database': b'database',
                  'Host': b'host', 'Port': b'port',
                  'User': b'username', 'Password': b'password'}
    url = URL('mysql')
    for config_key, url_attr in config_map.iteritems():
        setattr(url, url_attr, sql_config[config_key])
    logging.getLogger('amarok.covers').debug('connecting to %s', url)
    return url


def _bool(value):
    """
Return the boolean corresponding to ``value``.

Raise :exc:`ValueError`, if ``value`` is neither ``'true'`` nor
``'false'``.
"""
    if value not in ('true', 'false'):
        raise ValueError('invalid bool value: {0!r}'.format(value))
    return value == 'true'


def read_amarok_database_configuration():
    log = logging.getLogger('amarok.config')

    # configuration settings
    mysql = {}
    # maps type names from kcfg to conversion functions
    casts = {'Bool': _bool, 'Int': int, 'String': unicode}

    config_file = kde4_locate('config', 'amarokrc')
    log.debug('using configuration file at %s', config_file)
    schema_file = kde4_locate('kcfg', 'amarokconfig.kcfg')
    log.debug('using schema file at %s', schema_file)

    namespaces = {'kcfg': 'http://www.kde.org/standards/kcfg/1.0'}
    # XPath expression to read the default value of a configuration key
    get_default = etree.XPath('./kcfg:default/text()',
                              namespaces=namespaces)
    schema = etree.parse(schema_file).xpath(
        '//kcfg:group[@name="MySQL"]', namespaces=namespaces)[0]
    for entry in schema.xpath('./kcfg:entry', namespaces=namespaces):
        key = entry.get('key')
        try:
            default = get_default(entry)[0]
        except IndexError:
            default = None
        typename = entry.get('type')
        log.debug('reading %s with type %s, default %s from database '
                  'configuration', key, typename, default)
        value = kde4_read_config(config_file, 'MySQL', key, default=default)
        mysql[key] = casts[typename](value)

    return mysql


class color(object):
    COLORS = {'darkred': '\x1b[31m',
              'darkgreen': '\x1b[32m',
              'brown': '\x1b[33m',
              'purple': '\x1b[35m',
              'lightgray': '\x1b[37m'}
    RESET = '\x1b[39;49;00m'

    def __init__(self, value):
        self._value = value

    def __format__(self, color):
        return '{color}{value}{reset}'.format(
            color=self.__class__.COLORS[color], value=self._value,
            reset=self.__class__.RESET)

    def __getattr__(self, attr):
        v = self.__dict__['_value']
        if attr == '_value':
            return v
        else:
            return color(getattr(v, attr))


class ColorfulFormatter(object):
    """
Format :class:`logging:LogRecord` objects with pretty ASCII colors for
user-friendly output.

Unlike :class:`logging.Formatter` the output format of this class cannot
be configured as of now.

See :var:`TEMPLATE` for the format of the emitted message.
"""

    #: the message template. ``msgcolor`` is gray for debug messages and
    # green otherwise
    TEMPLATE = ('{1.levelname:purple}:{1.name:brown}: '
                '{1.message:{msgcolor}}')

    def format(self, record):
        """
Format the given ``record`` (a :class:`logging.LogRecord` instance)
and return the log message as string.
"""
        params = vars(record)
        params['message'] = record.getMessage()
        msgcolor = 'darkgreen'
        if record.levelno >= logging.WARNING:
            msgcolor = 'darkred'
        elif record.levelno <= logging.DEBUG:
            msgcolor = 'lightgray'
        text = self.TEMPLATE.format(self, color(record), msgcolor=msgcolor)
        if record.exc_info:
            from traceback import format_exception
            exc_text = ''.join(format_exception(*record.exc_info))
            text += '\n' + '{0:darkred}'.format(color(exc_text))
        return text


def _setup_logging(opts):
    logging.getLogger().setLevel(logging.NOTSET)
    stdout = logging.StreamHandler(sys.stdout)
    stdout.setFormatter(ColorfulFormatter())
    stdout.setLevel(opts.level)
    logging.getLogger().addHandler(stdout)
    if opts.log_sql:
        logging.getLogger('sqlalchemy.engine').setLevel(logging.DEBUG)
        logging.getLogger('sqlalchemy.pool').setLevel(logging.DEBUG)
    if opts.logfile:
        logfile_handler = logging.FileHandler(opts.logfile, 'w', 'utf-8')
        logfile_handler.setLevel(logging.DEBUG)
        logfile_handler.setFormatter(logging.Formatter(
            '%(asctime)s %(levelname)-5.5s %(name)s: %(message)s',
            '%Y-%m-%dT%H:%M:%S'))
        logging.getLogger().addHandler(logfile_handler)


def main():
    parser = OptionParser(
        usage='%prog', version='2.1',
        epilog="""\
Copyright (C) 2010 Sebastian Wiesner <lunaryorn@googlemail.com>,
distributed under the terms of the WTFPL 2 license""")
    parser.add_option('--log-sql', action='store_true',
                      help='Enable SQL debugging output. Needs option -d '
                      'or --logfile. Very chatty')
    parser.add_option('-d', '--debug', help='Enable debugging output. '
                      'Chatty', action='store_const', const=logging.DEBUG,
                      dest='level')
    parser.add_option('-v', '--verbose', help='Enable informative output',
                      action='store_const', const=logging.INFO,
                      dest='level')
    parser.add_option('--logfile', help='Log all output to the given FILE. '
                      'FILE will always contain all debugging output, '
                      'independent of option -d.', metavar='FILE')
    parser.add_option('-n', '--cover-name',
                      help='The cover name. If you specify an extension, '
                      'the cover is converted into the format denoted by '
                      'the extension. Otherwise the format is guessed '
                      'from the original cover, and the extension is '
                      'chosen appropriately. Defaults to "cover.png"')
    parser.add_option('-e', '--desktop-entries',
                      help='Create desktop entries for exported '
                      'covers. Compatible file managers will use the '
                      'cover as folder icon, if desktop entries are '
                      'created', action='store_true')
    parser.set_defaults(level=logging.WARNING, cover_name='cover.png')
    opts, args = parser.parse_args()
    if args:
        parser.error('superfluous arguments')

    _setup_logging(opts)

    # log version for debugging purposes
    import sqlalchemy
    logging.debug('export_amarok_covers %s with SQLAlchemy %s',
                  parser.version, sqlalchemy.__version__)

    try:
        sql_config = read_amarok_database_configuration()
        if not sql_config['UseServer']:
            logging.getLogger('amarok.database').critical(
                'amarok not configured for external database')
            return

        engine = create_engine(url_from_config(sql_config),
                               convert_unicode=True)
        export_covers(engine, opts.cover_name,
                      create_desktop_entries=opts.desktop_entries)
    except KeyboardInterrupt:
        logging.warn('interrupted')
    except Exception:
        logging.exception('unexpected error occurred, not all covers were exported')
    finally:
        logging.shutdown()


if __name__ == '__main__':
    main()
    
    
    
